﻿Option Strict On
Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Threading
Public Class Main

    Public Shared mreSemaphore As New ManualResetEvent(False)
    Public Shared blnSemaphore As Boolean = False

    Public Shared Sub Main()
        Dim port As Int32 = 22022
        'Der listener hoert nur auf lokale clients (127.0.0.1:22022)
        Dim tcpl As TcpListener = New TcpListener(New IPEndPoint(IPAddress.Loopback, port))

        Echo("Calling DoAcceptClient")
        Dim trdDAC As New Thread(New ParameterizedThreadStart(AddressOf DoAcceptClient))
        blnSemaphore = True
        trdDAC.Start(tcpl)

        'Warte bis der nutzer q in die Konsole eingibt.
        Do Until Console.ReadKey(True).KeyChar = "q" : Loop
        Echo("Received quit command finalizing... ")

        blnSemaphore = False
        'Semaphore -> Set
        mreSemaphore.Set()
    End Sub

    Public Shared Sub DoAcceptClient(objListener As Object)
        Dim listener As TcpListener = CType(objListener, TcpListener)
        While blnSemaphore
            Echo("Semaphore -> reset")
            mreSemaphore.Reset()

            Echo("Starting listener...")
            listener.Start()

            Echo("Waiting for connection... [BeginAcceptTcpClient]")
            listener.BeginAcceptTcpClient(New AsyncCallback(AddressOf DoAcceptClientCallback), listener)

            Echo("Semaphore -> waitone (set)")
            mreSemaphore.WaitOne()
        End While
        Echo("Left running loop!")
    End Sub

    Public Shared Sub DoAcceptClientCallback(ar As IAsyncResult)
        Dim listener As TcpListener = CType(ar.AsyncState, TcpListener)
        Echo("Casted listener [EndAcceptTcpClient]")
        Dim client As TcpClient = listener.EndAcceptTcpClient(ar)
        Echo("Receiving bytes...")
        Dim lb As Byte = 0
        '0x71 entspricht 'q'
        Do Until lb = &H71
            Dim bf() As Byte = New Byte() {0}
            client.Client.Receive(bf)
            lb = bf(0)
            Echo("Received byte: 0x" & Convert.ToString(lb, 16))
            client.Client.Send(New Byte() {&H6})
        Loop
        Echo("Client -> close")
        client.Close()
        Echo("Semaphore -> set")
        mreSemaphore.Set()
    End Sub

    Public Shared Sub Echo(msg As String)
        Console.WriteLine("[{0}]-: {1}", Thread.CurrentThread.ManagedThreadId, msg)
    End Sub
End Class